MDArtifact
Date: 2014-12-13

org.apache.ivy.core.module.descriptor

## Class MDArtifact

- java.lang.Object
- - org.apache.ivy.core.module.descriptor.AbstractArtifact
  - - org.apache.ivy.core.module.descriptor.MDArtifact

- All Implemented Interfaces:
    Artifact, ExtendableItem

      public class MDArtifact
      extends AbstractArtifact

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MDArtifact(ModuleDescriptor md, java.lang.String name, java.lang.String type, java.lang.String ext)`
    `MDArtifact(ModuleDescriptor md, java.lang.String name, java.lang.String type, java.lang.String ext, boolean isMetadata)`
    `MDArtifact(ModuleDescriptor md, java.lang.String name, java.lang.String type, java.lang.String ext, java.net.URL url, java.util.Map extraAttributes)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addConfiguration(java.lang.String conf)`
    `java.lang.String[]` | `getConfigurations()` Returns the list of configurations where this artifact is associated to.
    `java.lang.String` | `getExt()` Retrieve the extension of the artifact.
    `ArtifactRevisionId` | `getId()` Return the specific identifier of this artifact.
    `ModuleRevisionId` | `getModuleRevisionId()` Returns the resolved module revision id for this artifact
    `java.lang.String` | `getName()` Return the name of the artifact, generally 'part' of the basename of the file.
    `java.util.Date` | `getPublicationDate()` Returns the resolved publication date for this artifact
    `java.lang.String` | `getType()` Returns the type of the artifact, typically 'jar', 'source', 'javadoc', 'debian', ...
    `java.net.URL` | `getUrl()` Returns the url at which this artifact can be found independently of ivy configuration.
    `boolean` | `isMetadata()` Returns true if this artifact represents a module metadata artifact, false if it's a published artifact
    `static Artifact` | `newIvyArtifact(ModuleDescriptor md)`

    - ### Methods inherited from class org.apache.ivy.core.module.descriptor.AbstractArtifact

      `equals, getAttribute, getAttributes, getExtraAttribute, getExtraAttributes, getQualifiedExtraAttributes, hashCode, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MDArtifact

          public MDArtifact(ModuleDescriptor md,
                    java.lang.String name,
                    java.lang.String type,
                    java.lang.String ext)

    - #### MDArtifact

          public MDArtifact(ModuleDescriptor md,
                    java.lang.String name,
                    java.lang.String type,
                    java.lang.String ext,
                    boolean isMetadata)

    - #### MDArtifact

          public MDArtifact(ModuleDescriptor md,
                    java.lang.String name,
                    java.lang.String type,
                    java.lang.String ext,
                    java.net.URL url,
                    java.util.Map extraAttributes)

  - ### Method Detail

    - #### newIvyArtifact

          public static Artifact newIvyArtifact(ModuleDescriptor md)

    - #### getModuleRevisionId

          public ModuleRevisionId getModuleRevisionId()

      Description copied from interface: `Artifact`
      Returns the resolved module revision id for this artifact
      Returns:
        the resolved module revision id.

    - #### getPublicationDate

          public java.util.Date getPublicationDate()

      Description copied from interface: `Artifact`
      Returns the resolved publication date for this artifact
      Returns:
        the resolved publication date. Never null.

    - #### getId

          public ArtifactRevisionId getId()

      Description copied from interface: `Artifact`
      Return the specific identifier of this artifact.
      Returns:
        the id of the artifact

    - #### getName

          public java.lang.String getName()

      Description copied from interface: `Artifact`
      Return the name of the artifact, generally 'part' of the basename of the file.
      Returns:
        the name of the artifact. Never null.

    - #### getType

          public java.lang.String getType()

      Description copied from interface: `Artifact`
      Returns the type of the artifact, typically 'jar', 'source', 'javadoc', 'debian', ...
      Returns:
        the type of the artifact. Never null.

    - #### getExt

          public java.lang.String getExt()

      Description copied from interface: `Artifact`
      Retrieve the extension of the artifact. The extension is without dot (ie. 'jar' and not '.jar')
      Returns:
        the extension of the artifact. Never null.

    - #### getConfigurations

          public java.lang.String[] getConfigurations()

      Description copied from interface: `Artifact`
      Returns the list of configurations where this artifact is associated to.
      Returns:
        the list of configuration this artifact is associated to. Never null.

    - #### addConfiguration

          public void addConfiguration(java.lang.String conf)

    - #### getUrl

          public java.net.URL getUrl()

      Description copied from interface: `Artifact`
      Returns the url at which this artifact can be found independently of ivy configuration. This can be null (and is usually for standard artifacts)
      Returns:
        url at which this artifact can be found independently of ivy configuration

    - #### isMetadata

          public boolean isMetadata()

      Description copied from interface: `Artifact`
      Returns true if this artifact represents a module metadata artifact, false if it's a published artifact
      Returns:
        true if this artifact represents a module metadata artifact, false if it's a published artifact